Public Member Functions | Data Fields

# GoalQuestionWindow Struct Reference

Inheritance diagram for GoalQuestionWindow:

## Public Member Functions
| GoalQuestionWindow (const WindowDesc *desc, WindowNumber window_number, byte type, uint32 button_mask, const char *question)
virtual void | SetStringParameters (int widget) const
| Initialize string parameters for a widget.
virtual void | OnClick (Point pt, int widget, int click_count)
| A click with the left mouse button has been made on the window.
virtual void | UpdateWidgetSize (int widget, Dimension *size, const Dimension &padding, Dimension *fill, Dimension *resize)
| Update size and resize step of a widget in the window.
virtual void | DrawWidget (const Rect &r, int widget) const
| Draw the contents of a nested widget.
## Data Fields
char * | question
int | buttons
int | button [3]
byte | type

## Detailed Description

Definition at line 257 of file goal_gui.cpp.

## Member Function Documentation

virtual void GoalQuestionWindow::DrawWidget | ( | const Rect & | r,
|  | int | widget |
| ) |  |  | const`[inline, virtual]`

Draw the contents of a nested widget.

Parameters:

  | r | Rectangle occupied by the widget.
  | widget | Number of the widget to draw.

Note:
  This method may not change any state, it may only use drawing functions.

Reimplemented from Window.

Definition at line 338 of file goal_gui.cpp.

References DrawStringMultiLine(), SA_HOR_CENTER, SA_TOP, SetDParamStr(), and WID_GQ_QUESTION.

virtual void GoalQuestionWindow::OnClick | ( | Point | pt,
|  | int | widget,
|  | int | click_count |
| ) |  |  | `[inline, virtual]`

A click with the left mouse button has been made on the window.

Parameters:

  | pt | the point inside the window that has been clicked.
  | widget | the clicked widget.
  | click_count | Number of fast consecutive clicks at same position

Reimplemented from Window.

Definition at line 310 of file goal_gui.cpp.

References CMD_GOAL_QUESTION_ANSWER, DoCommandP(), WID_GQ_BUTTON_1, WID_GQ_BUTTON_2, and WID_GQ_BUTTON_3.

virtual void GoalQuestionWindow::SetStringParameters | ( | int | widget | ) | const`[inline, virtual]`

Initialize string parameters for a widget.

Calls to this function are made during initialization to measure the size (that is as part of InitNested()), during drawing, and while re-initializing the window. Only for widgets that render text initializing is requested.

Parameters:

  | widget | Widget number.

Reimplemented from Window.

Definition at line 289 of file goal_gui.cpp.

References SetDParam(), WID_GQ_BUTTON_1, WID_GQ_BUTTON_2, WID_GQ_BUTTON_3, and WID_GQ_CAPTION.

virtual void GoalQuestionWindow::UpdateWidgetSize | ( | int | widget,
|  | Dimension * | size,
|  | const Dimension & | padding,
|  | Dimension * | fill,
|  | Dimension * | resize |
| ) |  |  | `[inline, virtual]`

Update size and resize step of a widget in the window.

After retrieval of the minimal size and the resize-steps of a widget, this function is called to allow further refinement, typically by computing the real maximal size of the content. Afterwards, size is taken to be the minimal size of the widget and resize is taken to contain the resize steps. For the convenience of the callee, padding contains the amount of padding between the content and the edge of the widget. This should be added to the returned size.

Parameters:

  | widget | Widget number.
  | size | Size of the widget.
  | padding | Recommended amount of space between the widget content and the widget edge.
  | fill | Fill step of the widget.
  | resize | Resize step of the widget.

Reimplemented from Window.

Definition at line 330 of file goal_gui.cpp.

References GetStringHeight(), SetDParamStr(), and WID_GQ_QUESTION.

The documentation for this struct was generated from the following file:

- src/goal_gui.cpp